import { useState } from "react";
import { AreaRiservataLayout } from "~/components/Layout";
import { LoadingPage } from "~/components/loading";
import type { NextPageWithLayout } from "~/pages/_app";
import { api } from "~/utils/api";
import toast from "react-hot-toast";
import {
  Dialog,
  DialogContent,
  DialogDescription,
  DialogHeader,
  DialogTitle,
  DialogTrigger,
} from "~/components/ui/dialog";
import { Plus, RefreshCcw } from "lucide-react";
import { Status500 } from "~/components/status-page";
import { Button } from "~/components/ui/button";
import { StringheTable } from "~/components/tables/stringhe-table";
import type { TestiEStringhe } from "~/schemas/public/TestiEStringhe";
import { FormStringhe } from "~/forms/FormStringhe";

const AdminTestiStringhe: NextPageWithLayout = () => {
  const { data, isLoading, refetch } = api.settings.getStringhe.useQuery();
  const [openEdit, setOpenEdit] = useState(false);
  const [editData, setEditData] = useState<TestiEStringhe | null>(null);

  const handleOpen = (status: boolean) => {
    setOpenEdit(status);
  };
  const handleEdit = (data: TestiEStringhe | null) => {
    setEditData(data);
  };

  if (isLoading) return <LoadingPage />;
  if (!data) return <Status500 />;

  return (
    <div className="mx-1 flex-1 overflow-auto">
      <div className="mx-auto pt-4">
        <div className="mx-auto items-start justify-between px-2 md:flex">
          <div className="flex items-center gap-3">
            <h3 className="text-accent-foreground text-xl font-bold sm:text-2xl">
              Testi e Stringhe
            </h3>
            <button onClick={async () => await refetch()}>
              <RefreshCcw className="size-6" />
            </button>
          </div>

          <div className="mt-3 md:mt-0">
            <EditModal
              initial={editData}
              open={openEdit}
              setOpen={handleOpen}
            />
          </div>
          <div className="mt-3 md:mt-0">
            <Button
              onClick={() => {
                handleEdit(null);
                handleOpen(true);
              }}
              variant="outline"
              className="flex items-center gap-2 font-semibold"
            >
              <Plus className="size-6" />
              Nuovo
            </Button>
          </div>
        </div>

        <StringheTable
          data={data}
          setOpenEdit={handleOpen}
          setEditData={handleEdit}
        />
      </div>
    </div>
  );
};
export default AdminTestiStringhe;

AdminTestiStringhe.getLayout = function getLayout(page) {
  return <AreaRiservataLayout>{page}</AreaRiservataLayout>;
};

const EditModal = ({
  initial,
  open,
  setOpen,
}: {
  initial: TestiEStringhe | null;
  open: boolean;
  setOpen: (status: boolean) => void;
}) => {
  const utils = api.useUtils();
  const { mutate: edit } = api.settings.updateStringa.useMutation({
    onSuccess: async () => {
      toast.success("Successo");
      await utils.settings.getStringhe.invalidate();
      setOpen(false);
    },
    onError: (error) => {
      toast.error(error.message);
    },
  });
  const { mutate: add } = api.settings.newStringa.useMutation({
    onSuccess: async () => {
      toast.success("Successo");
      await utils.settings.getStringhe.invalidate();
      setOpen(false);
    },
    onError: (error) => {
      toast.error(error.message);
    },
  });
  const { mutate: del } = api.settings.deleteStringa.useMutation({
    onSuccess: async () => {
      toast.success("Successo");
      await utils.settings.getStringhe.invalidate();
      setOpen(false);
    },
    onError: (error) => {
      toast.error(error.message);
    },
  });

  return (
    <Dialog open={open} onOpenChange={setOpen}>
      <DialogTrigger asChild />
      <DialogContent className="sm:max-w-6xl">
        <DialogHeader>
          <DialogTitle>
            {!initial ? "Aggiungi Banner" : "Modifica Valori"}
          </DialogTitle>
          <DialogDescription className="sr-only">Edit</DialogDescription>
        </DialogHeader>
        {!initial ? (
          <div className="py-4">
            <FormStringhe
              submitMutation={(fields) => {
                add({
                  stringaId: fields.stinga_id,
                  stringaValue: fields.stringa_value,
                });
              }}
              initialValues={null}
            />
          </div>
        ) : (
          <div className="py-4">
            <FormStringhe
              submitMutation={(fields) => {
                edit({
                  stringaId: fields.stinga_id,
                  stringaValue: fields.stringa_value,
                });
              }}
              initialValues={{
                ...initial,
              }}
              del={(v) => del({ stringaId: v })}
            />
          </div>
        )}
      </DialogContent>
    </Dialog>
  );
};
